#include "types.h"
#include "LPC21xx.h"
#include "config.h"
#include "ps2kbd.h"
#include "armVIC.h"

//extern uint8_t kbdbytes;     // number of bytes received from keyboard
extern uint8_t kbdbits;    // number of received bits (start bit inclusive)
extern uint8_t kbdbyte;    // receiving byte
extern uint8_t kbdto;      // timeout for a keystroke receiving
//extern BOOL kbdtx;        // 1 when transmitting to keyboard, 0 when receiving
extern BOOL kbdbit;       // received bit
extern BOOL kbdoddparity; // 1 if odd number of bits before parity
extern BOOL kbderr;       // 1 if any errors

void extISR1(void)
{
//    BOOL paritybit;
    // called everytime the kbdclk goes low => must latch kbddata
    ISR_ENTRY();
    /* kbdto is decremented in a timer interrupt */
    if (kbdto==0)   // Control keyboard timeout (2 ms to receive a keystroke
    {
        kbderr=0;
        kbdbits=0;
        kbdoddparity=0;
        kbdto=3;  // set keyboard time out
//        kbdtx=0;
        KData_Set();//release data pin
    }
//    /* Transmitting */
//    if (kbdtx)
//    {
//        // transmit to keyboard
//        kbdbits++;
//        if (kbdbits<=8)
//        {
//            if (kbdbyte&1)
//            {
//                kbdoddparity^=1;
//                KData_Set();
//            }
//            else
//            {
//                KData_Clr();
//            }
//            kbdbyte>>=1;
//        }
//        else if (kbdbits==9)
//        {
////            //transmit parity
////            kbddata=~kbdoddparity;
//            paritybit = ~kbdoddparity;
//            if (paritybit == 0)
//                KData_Clr();
//            else
//                KData_Set();
//        }
//        else if (kbdbits==10)
//        {
//            KData_Set();// transmit stop bit
//        }
//        else if (kbdbits==11)
//        {
//            // get acknowledge
//            kbderr = KDataIn();
//            kbdtx=0;
//            kbdto=0;
//        }
//    }
//    /* Recieving */
//    else
//    {
        kbdbit = KDataIn();// read data
        if (kbdbits==0)
        {
            if (kbdbit)
            {
                kbderr=1;// control start bit(must be ZERO!)
            }
        }
        else if (kbderr==0)
        {
            if (kbdbits>=1 && kbdbits<=8)
            {
                kbdbyte>>=1;
                if (kbdbit)
                {
                    kbdbyte|=0x80;
                    kbdoddparity^=1;
                }
            }
            else if (kbdbits==9)
            {
                if (kbdbit==kbdoddparity)// parity BOOL
                {
                    kbderr=1;
                }
            }
            else if (kbdbits==10)
            {
                if (kbdbit==0)// stop BOOL
                {
                    kbderr=1;
                }
            }
        }
        if ((++kbdbits)==11)
        {
            if (kbderr==0)// no errors => store received byte to kbdbuffer
            {
                decode (kbdbyte);
//                kbdbuffer[kbdbytes]=kbdbyte;
//                if ((++kbdbytes)==KB_BUFFLEN)
//                {
////                    kbdclk=0;  // pulling kbddata low, keyboard communication will be inhibited
//                    KClock_Clr();
////                    kbdclkm=0;
//                }
            }
            kbdto=0;
        }
//    }
//    kbdintflag=0; // reset interrupt flag

    EXTINT = 0x00000002;	/* clear interrupt */
    VICVectAddr = 0;
    ISR_EXIT();

}//extISR
