#ifndef INC_PS2KBD_H
#define INC_PS2KBD_H
#include "config.h"

#define KBD_PINSEL  (0x20000000)
#define KBD_PINMASK (0x30000000)

#define KDATA_PIN        BIT(3)
#define KCLOCK_PIN       BIT(14)
#define KDataIn()        (IO0PIN & KDATA_PIN)
#define KClockIn()       (IO0PIN & KCLOCK_PIN)
#define KData_Clr()      (IO0CLR = KDATA_PIN)
#define KData_Set()      (IO0SET = KDATA_PIN)
#define KClock_Clr()     (IO0CLR = KCLOCK_PIN)
#define KClock_Set()     (IO0SET = KCLOCK_PIN)

/* Ascci assigned for the funkeys */
#define F1          0xF1
#define F2          0xF2
#define F3          0xF3
#define F4          0xF4
#define F5          0xF5
#define F6          0xF6
#define F7          0xF7
#define F8          0xF8
#define F9          0xF9
#define F10         0xFA
#define F11         0xFB
#define F12         0xFC

/* Key Scan Codes for function keys */
#define K_F1		0x05
#define K_F2		0x06
#define K_F3		0x04
#define K_F4		0x0C
#define K_F5		0x03
#define K_F6		0x0B
#define K_F7		0x83
#define K_F8		0x0A
#define K_F9		0x01
#define K_F10		0x09
#define K_F11		0x78
#define K_F12		0x07

#define K_TAB       0x0D
#define K_ENTER     0x5A
#define K_BACKSP    0x66
#define K_ESC       0x76
#define K_TAB       0x0D
/* Extended scand code */
#define K_HOME      0x6C
#define K_END       0x69
#define K_INSERT	0x70
#define K_DELETE	0x71
#define K_PGUP		0x7D /* PGUP is a synonym for PRIOR */
#define K_PGDN		0x7A /* PGDN is a synonym for NEXT */
#define K_DOWN		0x72
#define K_LEFT		0x6B
#define K_RIGHT		0x74
#define K_UP		0x75
#define K_SYSRQ     0x7C
/* Extended to ascii */
#define KeyHOME     0xFE
#define KeyEND      0xFF
#define KeyUP       0xE1
#define KeyDWN      0xE2
#define KeyLEFT     0xE3
#define KeyRIGHT    0xE4
#define KeyPGUP     0xE5
#define KeyPGDWN    0xE6
#define KeyINSERT   0xE7
#define KeyDELETE   0xE8
#define KeySYRQ     0xE9
/* Response */
#define RESEND      0xFE
#define ACK         0xFA

#define LEFTSHIFT   0x12
#define RIGHTSHIFT  0x59
#define CTRLKEY     0x14
#define ALTKEY      0x11
#define CAPSLOCK    0x58
#define	NUMLOCK     0x77
#define SCROLLLOCK  0x7E
/* Identifier */
#define BREAKCHAR   0xF0
#define DOUBLECODE  0xE1
#define ESCAPECODE  0xE0

#define KBLED_ON 1
#define KBLED_OFF 0

#define KBUFFSIZE 4

#define CAPSLED 0x04
#define NUMLED  0x01

struct KB_FLAGS{
    BOOL capsLock;
    BOOL scrollLock;
    BOOL numLock;
    BOOL shift;
    BOOL alt;
    BOOL ctrl;
}kb_flags;

DWORD cfgKeyboard(void);
void decode(unsigned char sc);
void putkeybuf(unsigned char c);
unsigned char xgetkey(void);
uint8_t keyhit(void);
void SendByte(uint8_t);
void SetKbd(void);
void extISR1(void) __attribute__ ((naked));
#endif

